From c4ddb4d172e2d048bd13b2840a8af75e90f2e3f0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 01 2020 17:00:17 +0000
Subject: [PATCH 509/2232] Add tests for by-value-not-supported errors


---

diff --git a/syntax/error.rs b/syntax/error.rs
index f52d651..f2cb8d1 100644
--- a/syntax/error.rs
+++ b/syntax/error.rs
@@ -44,7 +44,7 @@ pub static CXX_STRING_BY_VALUE: Error = Error {
 pub static CXX_TYPE_BY_VALUE: Error = Error {
     msg: "C++ type by value is not supported",
     label: None,
-    note: Some("hint: wrap it in a Box<> or UniquePtr<>"),
+    note: Some("hint: wrap it in a UniquePtr<>"),
 };
 
 pub static DOUBLE_UNDERSCORE: Error = Error {
diff --git a/tests/ui/by_value_not_supported.rs b/tests/ui/by_value_not_supported.rs
new file mode 100644
index 0000000..3ff950a
--- /dev/null
+++ b/tests/ui/by_value_not_supported.rs
@@ -0,0 +1,22 @@
+#[cxx::bridge]
+mod ffi {
+    struct S {
+        c: C,
+        r: R,
+        s: CxxString,
+    }
+
+    extern "C" {
+        type C;
+    }
+
+    extern "Rust" {
+        type R;
+
+        fn f(c: C) -> C;
+        fn g(r: R) -> R;
+        fn h(s: CxxString) -> CxxString;
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/by_value_not_supported.stderr b/tests/ui/by_value_not_supported.stderr
new file mode 100644
index 0000000..1ff8dbf
--- /dev/null
+++ b/tests/ui/by_value_not_supported.stderr
@@ -0,0 +1,53 @@
+error: using C++ type by value is not supported
+ --> $DIR/by_value_not_supported.rs:4:9
+  |
+4 |         c: C,
+  |         ^^^^
+
+error: using opaque Rust type by value is not supported
+ --> $DIR/by_value_not_supported.rs:5:9
+  |
+5 |         r: R,
+  |         ^^^^
+
+error: using C++ string by value is not supported
+ --> $DIR/by_value_not_supported.rs:6:9
+  |
+6 |         s: CxxString,
+  |         ^^^^^^^^^^^^
+
+error: passing C++ type by value is not supported
+  --> $DIR/by_value_not_supported.rs:16:14
+   |
+16 |         fn f(c: C) -> C;
+   |              ^^^^
+
+error: returning C++ type by value is not supported
+  --> $DIR/by_value_not_supported.rs:16:23
+   |
+16 |         fn f(c: C) -> C;
+   |                       ^
+
+error: passing opaque Rust type by value is not supported
+  --> $DIR/by_value_not_supported.rs:17:14
+   |
+17 |         fn g(r: R) -> R;
+   |              ^^^^
+
+error: returning opaque Rust type by value is not supported
+  --> $DIR/by_value_not_supported.rs:17:23
+   |
+17 |         fn g(r: R) -> R;
+   |                       ^
+
+error: passing C++ string by value is not supported
+  --> $DIR/by_value_not_supported.rs:18:14
+   |
+18 |         fn h(s: CxxString) -> CxxString;
+   |              ^^^^^^^^^^^^
+
+error: returning C++ string by value is not supported
+  --> $DIR/by_value_not_supported.rs:18:31
+   |
+18 |         fn h(s: CxxString) -> CxxString;
+   |                               ^^^^^^^^^

